/* -*- Mode: C++ -*-
 * $Id: intention_constants.h,v 1.2 2001/06/19 21:32:27 mikbr212 Exp $
 *
 * IDENTIFICATION
 *
 * Filename: view_constants.h
 * Unitname: Framework
 * $Revision: 1.2 $
 * Created by: Mikael Brnnstrm, Andreas Bckert & Andreas Sigfridsson
 * Last modified by $Author: mikbr212 $ $Date: 2001/06/19 21:32:27 $
 *
 * HISTORY
 *
 * $Log: intention_constants.h,v $
 * Revision 1.2  2001/06/19 21:32:27  mikbr212
 * Added intentions
 *
 * Revision 1.1  2001/06/19 14:11:43  mikbr212
 * Created
 *
 *
 */

/**
 * @file intention_constants.h
 * Include file with symbolic constants for the intention id's of
 * the intentions in RoboSoc.
 *
 * @par Unit:
 *      Framework
 * $Revision: 1.2 $
 * $Author: mikbr212 $
 * $Date: 2001/06/19 21:32:27 $
 */


#ifndef INTENTION_CONSTANTS_H
#define INTENTION_CONSTANTS_H

#include "machine_dependent_types.h"

RS_BEGIN_NAMESPACE

typedef UInt16 IntentionId;

/** The maximum intention id. */
static const IntentionId MAX_INTENTION_ID = 9;
/** Symbolic name for the id of the continue intention. */
static const IntentionId CONTINUE_INTENTION_ID = 1;
/** Symbolic name for the id of the take ball intention. */
static const IntentionId TAKE_BALL_INTENTION_ID = 2;
/** Symbolic name for the id of the advance ball (pass/dribble) intention. */
static const IntentionId ADVANCE_BALL_INTENTION_ID = 3;
/** Symbolic name for the id of the zone defence intention. */
static const IntentionId ZONE_DEFENCE_INTENTION_ID = 4;
/** Symbolic name for the id of the passable intention. */
static const IntentionId PASSABLE_INTENTION_ID = 5;
/** Symbolic name for the id of the assist offensive intention. */
static const IntentionId ASSIST_OFFENSIVE_INTENTION_ID = 6;
/** Symbolic name for the id of the look intention. */
static const IntentionId LOOK_INTENTION_ID = 7;
/** Symbolic name for the id of the goalie intention. */
static const IntentionId GOALIE_INTENTION_ID = 8;
/** Symbolic name for the id of the receive ball intention. */
static const IntentionId RECEIVE_BALL_INTENTION_ID = 9;

RS_END_NAMESPACE


#endif // INTENTION_CONSTANTS_H
