/* -*- Mode: C++ -*-
 * $Id: Dribble.h,v 1.8 2001/07/31 14:26:46 andbo928 Exp $
 *
 * IDENTIFICATION
 *
 * Filename: TurnBall.h
 * Unitname: Framework/skill
 * $Revision: 1.8 $
 * Created by: Fredrik Heintz 1999-xx-xx
 * Last modified by $Author: andbo928 $ $Date: 2001/07/31 14:26:46 $
 *
 *
 * HISTORY
 * $Log: Dribble.h,v $
 * Revision 1.8  2001/07/31 14:26:46  andbo928
 * Added setSafeCycles.
 *
 * Revision 1.7  2001/07/30 16:49:06  andbo928
 * Added setSpeed method.
 *
 * Revision 1.6  2001/07/30 11:00:54  andbo928
 * Implemented.
 *
 * Revision 1.5  2001/07/29 13:11:55  mikbr212
 * fixed the basics
 *
 * Revision 1.4  2001/07/29 12:48:37  mikbr212
 * New skill
 *
 *
 */

#ifndef DRIBBLE_H
#define DRIBBLE_H

#include "Skill.h"
#include "TLine.h"
#include "TVector.h"

#include "ParameterView.h"
#include "WorldStateView.h"

#include "rs_log.h"
#include "view_constants.h"

RS_BEGIN_NAMESPACE


/**
 * @class Dribble Dribble.h
 * This class implements the dribble skill
 *
 * @todo Finetune the skill.
 * -->
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.8 $
 * $Author: andbo928 $
 * $Date: 2001/07/31 14:26:46 $
 */

class Dribble : public Skill {
public:
  Dribble();
  virtual ~Dribble();
 
  virtual Plan generatePlan();
  virtual FuzzyBool persistent();
  virtual FuzzyBool applicable();

  void setSpeed(double v0);
  void setSafeCycles(int cycles);

protected:
  int planTime;
  Plan thePlan;
  bool unsafe;
  double dribbleSpeed;
  int maxSteps;

  bool isOpponentClose(float nearDist);
  bool shouldLook();

  ParameterView* parameterView;
  WorldStateView* worldStateView;

  /** Hide copy-constructor. */
  Dribble(const Dribble&);
  /** Hide assignment operator. */
  Dribble& operator= (const Dribble&);
};


RS_END_NAMESPACE

#endif // !DRIBBLE_H
