#ifndef _GENEPOOL_H_
#define _GENEPOOL_H_
//#include <string>

#include "Skill.h"

#include "CoordVector.h"
#include "CoordPoint.h"
#include "view_constants.h"
#include "ParameterView.h"
#include "MarkerView.h"
#include "AgentView.h"
#include "BallView.h"
#include "rs_log.h"
#include "KickBallToSpeedVectorMulti.h"

#include "Operation.h"
#include "FloatMath.h"
#include "ObjMath.h"
#include "CommandOps.h"
#include "PointMath.h"
#include "StringOps.h"

RS_BEGIN_NAMESPACE

//#include "String.h"
#include "CoordPoint.h"

class GenePool {
public:
  GenePool();
  ~GenePool();

  Operation* getGene();
  void addGene(float util, Operation* gene);
  bool isEmpty();

private:

  int getRandomIndex();


  int countOperations(Operation *op);
  std::vector<Operation*> getOperations(Operation *op);
  std::vector<Operation*> getOperations(Operation *op, opType type);

  Operation* spliceGenes(Operation *gene1, Operation* gene2);

  float randomFloat();
  Point randomPoint();
  std::string randomString();

  Operation* setRandomArguments(Operation *o);
  Operation* getRandomFloatGene();
  Operation* getRandomStringGene();
  Operation* getRandomPointGene();

  Operation* mutate(Operation *gene);
  void decimate();

  std::vector<Operation*> genes;
  std::vector<float> utility;
  std::vector<int> numOffsprings;
};

RS_END_NAMESPACE
#endif



