#ifndef MARKPOSITION_H
#define MARKPOSITION_H


// Include the system header which definitions you use.
//#include <...>
//#include <...>

// Include the header files which definitions you use.
#include "Skill.h"
#include "view_constants.h"
#include "rs_log.h"
#include "WorldStateView.h"
#include "MoveToPosition.h"
#include "TLine.h"

RS_BEGIN_NAMESPACE

//class ParameterView;
//class MarkerView;
//class AgentView;
//class BallView;
class StatisticsView;

/**
 * @class MarkPosition MarkPosition.h
 * This class implements the pass skill
 *
 * <!--
 * @pre HaveBall, visible players.
 * @post Ball hopefully at the closest passable player.
 * @invariant ?!?!
 *
 * @todo Finetune the skill.
 * -->
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.5 $
 * $Author: sigge $
 * $Date: 2001/07/16 15:35:08 $
 */

class MarkPosition : public Skill {
public:
  /** Default constructor. Here you can initialize the skill. */
  MarkPosition();

  /** Destructor should clean up after the skill. */
  virtual ~MarkPosition();
  
  /** This method is used to generate a plan for how the goal of
    the skill should be obtained by the agent. You can assume
    that the preconditions of the skill are true (this can be tested
    by calling the applicable() method, after you have implemented it). */
  virtual Plan generatePlan();

  /** This method should return a FuzzyBool telling the caller
    if the skill wants to be called again. */
  virtual FuzzyBool persistent();

  /** This method should implement the precondition specified in
   the description of the skill. */
  virtual FuzzyBool applicable();

  void setPosition(const TVector& pos);

  void setLookAtMark(bool enabled = true);
  void setBuffer(double bufSize = 1.5);
  void setDistance(double dist = 5.0);

  void setDistantPosition(const TVector& pos);
  void setBallAsDistantPosition(bool flag = true);
protected:

  WorldStateView* worldView;
  StatisticsView* statisticsView;

  TVector position;
  double distance;
  double distanceBuffer;

  TVector distantPosition;
  bool ballIsDistantPosition;

  TLine markLine;
  TLine moveLine;
  MoveToPosition moveSkill;

  bool lookAtMark;


  /** Hide copy-constructor. */
  MarkPosition(const MarkPosition&);
  /** Hide assignment operator. */
  MarkPosition& operator= (const MarkPosition&);
};


RS_END_NAMESPACE

#endif // !MARKPOSITION_H

