/* -*- Mode: C++ -*-
 * $Id: SkillGoToPosition.cc,v 1.1.1.1 2001/04/08 11:33:58 sigge Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz olalu526<@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: SkillGoToPosition.cc
 * Unitname: Framework/skill
 * $Revision: 1.1.1.1 $
 * Created by: Fredrik Heintz 2000-09-07
 * Last modified by $Author: sigge $ $Date: 2001/04/08 11:33:58 $
 *
 *
 * HISTORY
 *
 * $Log: SkillGoToPosition.cc,v $
 * Revision 1.1.1.1  2001/04/08 11:33:58  sigge
 * Imported sources
 *
 * Revision 1.2  2000/10/07 18:02:34  perpe427
 * Restructured inheritage for MoveToPositionFacing*-skills
 *
 * Revision 1.1  2000/10/07 14:28:25  olalu526
 * Added some skill files and fixed things.
 *
 * Revision 1.3  2000/09/16 18:39:39 olalu526 
 * Fixed the log messages.
 *
 * Revision 1.2  2000/09/16 18:36:48 olalu526 
 * Made minor fixes the skill stubs.
 *
 * Revision 1.1  2000/09/07 16:10:34 olalu526 
 * Added stubs for the skills.
 *
 */

/**
 * @file SkillGoToPosition.cc
 * Implementation file for the skill class SkillGoToPosition.
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.1.1.1 $
 * $Author: sigge $
 * $Date: 2001/04/08 11:33:58 $
 */


#include "SkillGoToPosition.h"


RS_BEGIN_NAMESPACE


// --- CONSTRUCTORS ---

SkillGoToPosition::SkillGoToPosition()
  // This is an initializer list
  // which means that all the objects inside the
  // class can be initialized after the colon.
  // You initialize the variable myVar with
  // myVar(constructor arguments).
  // You should also initialize the base classes, but
  // only the classes that you directly inherit from.
  // If you do not initialize a variable its default
  // constructor will be called.
  : Skill()
{
}


// --- DESTRUCTOR ---

SkillGoToPosition::~SkillGoToPosition()
{
}


// --- METHODS ---

void 
SkillGoToPosition::setMinStaminaWhenFinished(Float s)
{
  minStaminaWhenFinished = s;
}

Float
SkillGoToPosition::getMinStaminaWhenFinished() const
{
  return minStaminaWhenFinished;
}

void
SkillGoToPosition::setMaxStaminaUsedWhenFinished(Float s)
{
  setMinStaminaWhenFinished(agentView->getStamina(NOW) - s);
}

Float
SkillGoToPosition::getMaxStaminaUsedWhenFinished() const
{
  return agentView->getStamina(NOW) - getMinStaminaWhenFinished();
}

UInt
SkillGoToPosition::cyclesToReach()
{
}

Float
SkillGoToPosition::timeToReach()
{
}

FuzzyBool
SkillGoToPosition::reachable(UInt)
{
}

FuzzyBool
SkillGoToPosition::reachable(Point, UInt)
{
}

void 
SkillGoToPosition::setFaceAngle(const AngleDeg &a)
{
  angle = a;
}

AngleDeg
SkillGoToPosition::getFaceAngle() const
{
  return angle;
}

RS_END_NAMESPACE


// Remove from here
/* CONDITIONAL INCLUSION OF INLINE DEFINITIONS
 *
 * If the compiler or debugger does not understand the keyword inline then
 * include the inline definitions here, otherwise include them in the
 * declaration file.
 *
 * This is controlled by a flag called RS_USE_INLINE, which is usually
 * defined. It can be set by the user by giving the compiler an argument
 * usually -DRS_USE_INLINE (to define it) or -URS_USE_INLINE (to undefine it).
 */

#ifndef RS_USE_INLINE
#  include "SkillGoToPosition.icc"
#endif
// To here if you do not have any inline definitions!
