/* -*- Mode: C++ -*-
 * $Id: TakeBall.cc,v 1.1.1.1 2001/04/08 11:33:58 sigge Exp $
 *
 *
 * COPYRIGHT INFORMATION
 *
 * This file is part of RoboSoc created by Fredrik Heintz <frehe@ida.liu.se>
 * Copyright (C) 1999, 2000 Fredrik Heintz, Linkping University, Sweden
 *
 * You are allowed to modify and use this code as long as you retain this
 * notice. If you make any changes or have any comments I would appreciate
 * it if you send me a message. For more information, please see
 * http://www.ida.liu.se/~frehe/RoboCup/RoboSoc/
 *
 *
 * IDENTIFICATION
 *
 * Filename: TakeBall.cc
 * Unitname: Framework/skill
 * $Revision: 1.1.1.1 $
 *
 *
 * HISTORY
 * $Log: TakeBall.cc,v $
 * Revision 1.1.1.1  2001/04/08 11:33:58  sigge
 * Imported sources
 *
 */

/**
 * @file TakeBall.cc
 * Implementation file for the skill class TakeBall.
 *
 * @par Unit:
 *      Framework/skill
 * $Revision: 1.1.1.1 $
 * $Author: sigge $
 * $Date: 2001/04/08 11:33:58 $
 */

#include "TakeBall.h"

RS_BEGIN_NAMESPACE

/**
 */
TakeBall::TakeBall()
  : Skill(),
    intercept(),
    kick(Vector(0,0)),
    go(),
    parameterView(NULL),
    kickBallView(NULL)
{
  BallView* ballView;
  AgentView* agentView;
  CommandView* commandView;

  getView(parameterView, PARAMETER_VIEW_ID);
  getView(ballView, BALL_VIEW_ID);
  getView(agentView, AGENT_VIEW_ID, parameterView);
  getView(commandView, COMMAND_VIEW_ID);
  getView(kickBallView, KICKBALL_VIEW_ID, parameterView,
	  ballView, agentView, commandView);
} 

/**
 */
TakeBall::~TakeBall()
{
  viewManager->releaseView(PARAMETER_VIEW_ID);
  viewManager->releaseView(BALL_VIEW_ID);
  viewManager->releaseView(AGENT_VIEW_ID);
  viewManager->releaseView(COMMAND_VIEW_ID);
  viewManager->releaseView(KICKBALL_VIEW_ID);
}

/**
 */
Plan TakeBall::generatePlan()
{
  Vector ballSpeed, ballPos;
  if(!kickBallView->initBall(ballSpeed, ballPos))
    return Plan();

  if(
  
}

/**
 */
FuzzyBool TakeBall::persistent()
{
  return FALSE;
}

/**
 */
FuzzyBool TakeBall::applicable()
{
  return !plan.empty();
}


RS_END_NAMESPACE
