package robosoc;

import java.io.*;
import java.util.*;

public class ListInputStream {
  public static void main(String[] args) {
    ListInputStream l = new ListInputStream(System.in);
    Object o;
    try {
      while(true) {
	System.out.println("Mata in:");
	o = l.read();
	System.out.println("="+o.toString());
      }
    } catch (Exception e) {
      System.out.println(e.toString());
    }
  }

  private InputStream in;
    
  public ListInputStream(InputStream inputStream) {
    in = inputStream;
  }

  public Object read() throws java.io.IOException {
    return read(in.read());
  }
 
  private boolean listEnd;
  
  private Object read(int ch) throws java.io.IOException {
    listEnd = false;

    while(Character.isWhitespace((char)ch))
      ch = in.read();

    if(ch == '(') { // begin list
      ArrayList list = new ArrayList();
      while(true) {
	ch = in.read();

	while(Character.isWhitespace((char)ch))
	  ch = in.read();

	if(ch == ')')
	  return list; 
	else if(ch == -1)
	  throw new RuntimeException("ParseError");
	else {
	  list.add(read(ch));
	  if(listEnd) {
	    listEnd = false;
	    return list;
	  }
	}
      }
    } else { // begin string
      StringBuffer strbuf = new StringBuffer();
      if(ch == '"') {
	  ch = in.read();
	  while(ch != '"') {
	      strbuf.append((char)ch);
	      ch = in.read();
	  }
	  ch = in.read();
	  if(ch == ')')
	      listEnd = true;
	  return strbuf.toString();
      } else {
	  strbuf.append((char)ch);
	  while(true) {
	      ch = in.read();
	      if(Character.isWhitespace((char)ch)) {
		  return strbuf.toString();
	      } else if(ch == ')') {
		  listEnd = true;
		  return strbuf.toString();
	      } else {
		  strbuf.append((char)ch);
	      }
	  } // while
      }
    }
  }
}


